<?php
/*
 // "Jx Include Item" Plugin by Olle Johansson for K2 v2.x - Version 1.0
 // Copyright (c) 2009 Olle Johansson. All rights reserved.
 // Released under the GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 // More info at http://www.jxdevelopment.com
 */

 # TODO: Modify elements/article.php to read k2article

// no direct access
defined('_JEXEC') or die ('Restricted access');
JLoader::register('K2Plugin', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'lib'.DS.'k2plugin.php');

class plgK2JxIncludeItem extends K2Plugin {

	// Some params
	var $pluginName = 'jxincludeitem';
	var $pluginNameHumanReadable = 'Jx Include Item';

	function plgK2JxIncludeItem( & $subject, $params) {
	
		parent::__construct($subject, $params);
	}

	function onK2PrepareContent( & $item, & $params, $limitstart) {
        // Get plugin parameters
		$plugin = & JPluginHelper::getPlugin('k2', 'jxincludeitem');
		$pluginParams = new JParameter($plugin->params);
        $viewfields = explode(' ', $pluginParams->get('viewfields', array()));
        $title = $pluginParams->get('title', 'Included Item');
        $linktext = $pluginParams->get('linktext', '');
        if (count($viewfields) < 1) return;
	
        // Get K2 item parameters
		$plugins = new K2Parameter($item->plugins, '', $this->pluginName);
		$included = (int) $plugins->get('includeditem');
        if (!$included) return;

        # Read included K2 item
        JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
        $k2model = new K2ModelItem();
        $k2table = & JTable::getInstance('K2Item', 'Table');
        $k2table->load($included);
        if ((!$k2table->published) || (!$k2table->title)) return;
        $extra_fields = $k2model->getItemExtraFields($k2table->get('extra_fields'));

        // Get category
        $category = & JTable::getInstance('K2Category', 'Table');
        $category->load($item->catid);

        // Read more link
        $link = K2HelperRoute::getItemRoute($k2table->id.':'.urlencode($k2table->alias),$k2table->catid.':'.urlencode($category->alias));
        $k2table->link=urldecode(JRoute::_($link));

        // Setup the information box
        $content = "<div class='includeditem_box'>";
        $content .= "<h3 class='includeditem_header'>{$title}</h3>\n";
        foreach ($extra_fields as $f) {
            if (!in_array($f->id, $viewfields)) continue;
            if (!$f->value || !$f->published) continue;
            $content .= "<span class='field_row'>\n";
            $content .= "<span class='field_name'>{$f->name}:</span>\n";
            $content .= "<span class='field_value'>{$f->value}</span>\n";
            $content .= "<br /></span>\n";
        }
        if ($linktext) {
            $content .= "<span class='includeditem_link'><a href='{$k2table->link}'>$linktext</a></span>\n";
        }
        $content .= "</div>\n";

        #$item->text .= "Included: $included, Included2: $included2, item: " . print_r($item, true);
        $item->text = $content . $item->text;
	}

} // END CLASS

